module ast.Module;

import sema.Scope,
       sema.Symbol;

import ast.Decl;

class Module
{
    this(char[] moduleName)
    {
        this.moduleName = moduleName;
    }

    void addDecl(Decl decl)
    {
        switch(decl.declType)
        {
            case DeclType.FuncDecl:
                functions ~= cast(FuncDecl)decl;
                break;
            case DeclType.VarDecl:
                vars ~= cast(VarDecl)decl;
                break;
            case DeclType.StructDecl:
                structs ~= cast(StructDecl)decl;
                break;
            default:
                assert(0, "DeclType not implemented");
        }
        decls ~= decl;
    }

    VarDecl[] vars;
    FuncDecl[] functions;
    StructDecl[] structs;
    Decl[] decls;

    char[] moduleName;
    Scope env;
    Symbol symbol;
    bool outputModule = true;
}

